package tsuteto.tdkddoor;

import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.Minecraft;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.network.INetworkManager;
import net.minecraft.network.packet.Packet250CustomPayload;
import net.minecraft.src.ModLoader;
import net.minecraft.world.WorldServer;
import net.minecraft.world.storage.SaveHandler;
import net.minecraftforge.common.Configuration;
import net.minecraftforge.common.MinecraftForge;
import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.network.IPacketHandler;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.network.Player;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * The Main Class of Dokodemo Travel Door Mod 2
 *
 * @author tsuteto
 *
 */
@Mod(modid = TravelDokodemoDoorMod.modid, version = "2.1.5-MC1.6.2")
public class TravelDokodemoDoorMod {
	public static int itemIdWood = 3690;
	public static int itemIdIron = 3691;
	public static int itemIdOriginal = 3689;
	public static int blockIdWood = 1398;
	public static int blockIdIron = 1399;
	public static int blockIdOriginal = 1397;

	public static boolean travelStableArea = true;
	public static boolean isTravelLogEnabled = false;

	public static final String modid = "TravelDokodemoDoor";
	public static Item itemTdkdDoorWood;
	public static Item itemTdkdDoorIron;
	public static BlockTdkdDoor blockTdkdDoorWood;
	public static BlockTdkdDoor blockTdkdDoorIron;

	@SidedProxy(clientSide = "tsuteto.tdkddoor.TravelDokodemoDoorMod$ClientProxy", serverSide = "tsuteto.tdkddoor.TravelDokodemoDoorMod$ServerProxy")
	public static ISidedProxy sidedProxy;

	public static TdkdDoorSaveHandler saveHandler = null;

	static
	{
	    // Logger preparation
	    ModLog.modId = TravelDokodemoDoorMod.modid;
	    ModLog.isDebug = false;
	}

	@Mod.EventHandler
	public void preload(FMLPreInitializationEvent event)
	{
	    // Load settings
        Configuration conf = new Configuration(event.getSuggestedConfigurationFile());
        conf.load();
        itemIdWood = conf.getItem("item", "onewayDoor", itemIdWood).getInt();
        itemIdIron = conf.getItem("item", "twowayDoor", itemIdIron).getInt();
        blockIdWood = conf.getBlock("block", "onewayDoor", blockIdWood).getInt();
        blockIdIron = conf.getBlock("block", "twowayDoor", blockIdIron).getInt();

        travelStableArea = conf.get("general", "travelStableArea", travelStableArea,
                "The doors allow you to travel within stable area (<8,300,000) if true, or whole playable area (<30,000,000)")
                .getBoolean(travelStableArea);

        isTravelLogEnabled = conf.get("general", "travelLog", isTravelLogEnabled,
                "This mod logs traveling with the doors if true.")
                .getBoolean(isTravelLogEnabled);
        conf.save();
	}

	@Mod.EventHandler
	public void load(FMLInitializationEvent event) {
	    // Register event handler for location adjustment after teleportation of player
	    MinecraftForge.EVENT_BUS.register(new LocationAdjuster());

	    // Register items
		itemTdkdDoorWood = new ItemTdkdDoor(itemIdWood, Material.wood)
				.setUnlocalizedName("tdkddoor:tdkdDoorWood")
				.setCreativeTab(CreativeTabs.tabTransport);
		itemTdkdDoorIron = new ItemTdkdDoor(itemIdIron, Material.iron)
				.setUnlocalizedName("tdkddoor:tdkdDoorIron")
				.setCreativeTab(CreativeTabs.tabTransport);

		// Register blocks
		blockTdkdDoorWood = (BlockTdkdDoor)new BlockTdkdDoor(blockIdWood, Material.wood)
				.setHardness(3F)
				.setLightValue(0.75F)
				.setStepSound(Block.soundWoodFootstep)
				.setUnlocalizedName("tdkdDoorWood");

		blockTdkdDoorIron = (BlockTdkdDoor)new BlockTdkdDoor(blockIdIron, Material.iron)
				.setHardness(6F)
				.setLightValue(0.75F)
				.setResistance(50F)
				.setStepSound(Block.soundMetalFootstep)
				.setUnlocalizedName("tdkdDoorIron");

		GameRegistry.registerBlock(blockTdkdDoorWood, "dokodemoDoorWood");
		GameRegistry.registerBlock(blockTdkdDoorIron, "dokodemoDoorIron");

		// Register channel for packet communication
		NetworkRegistry.instance().registerChannel(new TdkdPacketHandler(), "tdkddoor");

		// Add localization
		ModLoader.addName(itemTdkdDoorWood, "en_US", "Anywhere Travel One-Way Door");
		ModLoader.addName(itemTdkdDoorWood, "ja_JP", "遠征どこでも片道ドア");
		ModLoader.addName(itemTdkdDoorIron, "en_US", "Anywhere Travel Door");
		ModLoader.addName(itemTdkdDoorIron, "ja_JP", "遠征どこでもドア");
		ModLoader.addName(blockTdkdDoorWood, "en_US", "Anywhere Travel One-Way Door");
		ModLoader.addName(blockTdkdDoorWood, "ja_JP", "遠征どこでも片道ドア");
		ModLoader.addName(blockTdkdDoorIron, "en_US", "Anywhere Travel Door");
		ModLoader.addName(blockTdkdDoorIron, "ja_JP", "遠征どこでもドア");

		ModLoader.addLocalization("tdkddoor.distance", "en_US", "You have traveled %s kilometers!");
		ModLoader.addLocalization("tdkddoor.distance", "ja_JP", "%skmを移動した！");
		ModLoader.addLocalization("tdkddoor.teleporting1", "en_US", "Teleporting somewhere in the world");
		ModLoader.addLocalization("tdkddoor.teleporting1", "ja_JP", "ワールドのどこかにテレポート中");
		ModLoader.addLocalization("tdkddoor.teleporting2", "en_US", "Teleporting to the other door");
		ModLoader.addLocalization("tdkddoor.teleporting2", "ja_JP", "もうひとつのドアへテレポート中");

		// Add recipes
		ModLoader.addRecipe(new ItemStack(itemTdkdDoorWood),
				new Object[]{
					"XX",
					"XY",
					"XX",
					Character.valueOf('X'), Block.planks,
					Character.valueOf('Y'), Item.enderPearl
		});
		ModLoader.addRecipe(new ItemStack(itemTdkdDoorIron),
				new Object[]{
					"XX",
					"XY",
					"XX",
					Character.valueOf('X'), Item.ingotIron,
					Character.valueOf('Y'), Item.enderPearl
		});
	}

	@Mod.EventHandler
	private void onServerStarting(FMLServerStartingEvent event)
	{
	    WorldServer world = event.getServer().worldServers[0];

        saveHandler = new TdkdDoorSaveHandler(
                ((SaveHandler)world.getSaveHandler()).getWorldDirectory(),
                world.getSaveHandler().getWorldDirectoryName());
	}

	/**
	 * Packet handler currently only for teleportation sound
	 * @author Tsuteto
	 *
	 */
	private class TdkdPacketHandler implements IPacketHandler {
		private Random rand = new Random();

		@Override
		public void onPacketData(INetworkManager manager,Packet250CustomPayload packet, Player player) {
			Minecraft mc = FMLClientHandler.instance().getClient();
            mc.sndManager.playSoundFX("portal.travel", 1.0F, rand.nextFloat() * 0.4F + 0.8F);
		}
	}

	@SideOnly(Side.CLIENT)
	public static class ClientProxy implements ISidedProxy
	{
		@Override
		public void registerTextures(String textureFile)
		{
		}
	}

	@SideOnly(Side.SERVER)
	public static class ServerProxy implements ISidedProxy
	{
		@Override
		public void registerTextures(String textureFile) {}
	}

	public static interface ISidedProxy {
		public void registerTextures(String textureFile);
	}

}
